#include "Tlc5940.h"

//////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////VARIABLES GLOBALES////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

int comando=0;  //Variable cuyo valor nos llegará desde Processing.
int matriz_botones[4][4] = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};  //Aquí se guardan los estados de cada uno de los botones.
int numeroLeds=0, Led=0, intensidadLed=0;  //Variables para recibir el numero de Leds a encender, la posición del Led que quiero encender y la intensidad de dicho Led
//Matriz para encender los leds en el orden establecido:
int matriz_cambio[48]={39,38,37,36,35,34,43,44,45,40,41,42,32,33,16,17,18,19,14,13,12,46,47,15,20,21,22,23,24,25,8,7,6,11,10,9,26,27,28,29,30,31,2,1,0,5,4,3};
int matriz_leds[4][4][3] = {{{39,38,37},{32,33,16},{20,21,22},{26,27,28}},{{36,35,34},{17,18,19},{23,24,25},{29,30,31}},{{43,44,45},{14,13,12},{8,7,6},{2,1,0}},{{40,41,42},{46,47,15},{11,10,9},{5,4,3}}};
int animacion=0;

//////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////VARIABLES DEL JUEGO///////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

int Led_partida[20]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,};
int partida=0;
int Led_Rojos[16]={39,32,20,26,36,17,23,29,43,14,8,2,40,46,11,5};
int Led_Verdes[16]={38,33,21,27,35,18,24,30,44,13,7,1,41,47,10,4};
int Led_Azules[16]={37,16,22,28,34,19,25,31,45,12,6,0,42,15,9,3};
int array_botones[16]={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
int Acierto=0;
boolean boton_pulsado=false;


//////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////COMIENZO DEL PROGRAMA//////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

void setup() {
  Serial.begin(9600);
  Tlc.init();  //Iniciamos la librería del TLC
  pinMode(2,INPUT);
  pinMode(4,INPUT);
  pinMode(5,INPUT);
  pinMode(6,INPUT);
  analogWrite(A0,1023);
  analogWrite(A1,1023);
  analogWrite(A2,1023);
  analogWrite(A3,1023);
  randomSeed(micros()*analogRead(5));
}

void loop()
{
  delay(100);
  Animacion_Inicial();
  Juego_Simon();
  //Enciende_Leds();
  //Lectura_Processing();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Animacion_Inicial(){  //Funcion para realizar la animación inicial
  if(animacion==0){
    Enciende_Leds_Aleatorios();  //Enciende Leds aleatorios
    delay(10);
    Tlc.setAll(4095);  //Enciende todos los Leds
    Tlc.update();
    delay(1000);
    Tlc.setAll(0);  //Apaga todos los Leds
    Tlc.update();
    delay(10);
    Enciende_Leds_Verdes();  //Enciende los Leds Verdes
    Enciende_Leds_Rojos();  //Enciende los Leds Rojos
    Enciende_Leds_Azules();  //Enciende los Leds Azules
    delay(500);
    animacion=1;
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Juego_Simon(){  //Juego del Simon
  delay(50);
  int k=0;
  Led_partida[partida]=random(0,16);  //Asignamos un led aleatorio para encenderlo
  for(int i=0;i<=partida;i++){
    Tlc.set(Led_Azules[Led_partida[i]],4095);  //Encendemos los leds de la partida (Dependerá del nivel de la partida) (partida=0 -> 1 LED)
    Tlc.update();
    delay(1000/(partida+1));  //El tiempo de encendido irá disminuyendo por cada partida
    Tlc.set(Led_Azules[Led_partida[i]],0);  //Apagamos el Led que encendimos anteriormente
    Tlc.update();
    delay(500/(partida+1));  //Tiempo del Led apagado
  }
  //Comprobacion de los botones pulsados:
  for(int i=0;i<=partida;i++){  //Recogemos tantas pulsaciones de boton como nivel de partida sea +1 (ya que el primer nivel es el 0)
    boton_pulsado=false;
    while(!boton_pulsado){  //Mientras no se haya pulsado un boton estaremos en el while
      Captura_Estado_Botones();  //Capturamos el estado de todos los botones
      Enciende_Leds();  //Encendemos el LED RGB del boton pulsado
      k=0;
      for(int a=0;a<4;a++){
        for(int b=0;b<4;b++){
          array_botones[k]=matriz_botones[a][b];  //Convierto la matriz de botones en un array para comprobar el que se corresponde el led con el boton
          k++;
        }
      }

      for(int busco_boton=0;busco_boton<16;busco_boton++){
        if(array_botones[busco_boton]==0){  //Si hay un boton pulsado...
          boton_pulsado=true;  //Activamos la variable para que salga del while
          if(busco_boton==Led_partida[i]){  //Si el boton pulsado coincide con el Led encendido...
            Acierto++;  //Incrementamos el numero de aciertos
          }
          else if(busco_boton!=Led_partida[i]){  //Si no coincide...
            partida=0;  //Empezamos de nuevo el juego
            Acierto=0;  //Los aciertos pasan a ser 0
            Enciende_Leds_Rojos();  //Encendemos todos los Leds Rojos para indicar que hemos perdido
            delay(20);
          }  
        }
      }
    }
    delay(1000);
  }
  if(Acierto==partida+1){  //Si el numero de aciertos se corresponde con el nivel de la partida+1 (ya que el nivel empieza en 0)...
    partida++;  //Incrementamos el nivel de la partida ya que se ha superado
    Acierto=0;  //Ponemos los aciertos a 0 para el nuevo nivel
    Enciende_Leds_Verdes();  //Encendemos todos los Leds Verdes para indicar que hemos pasado de nivel
    delay(20);
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Lectura_Processing(){  //Funcion para hacer la comunicacion con Processing
  if(comando==0){
    if (Serial.available() > 0) {
      comando = Serial.read();
    }
  }
  else if(comando>0){
    switch (comando) {
    case 1:  //Lectura
      delay(100);
      Captura_Estado_Botones();  //Capturamos el estado de los botones para mandarlo a Processing
      delay(100);
      //Mando el valor de los botones pulsados
      for(int i=0;i<4;i++) {  //Aumento la columna
        for(int j=0;j<4;j++) {  //Aumento la fila
          Serial.write(matriz_botones[j][i]);  //Recorro por columnas y mando el estado de cada botón.
          delay(50);
        }
      }
      comando=0;
      break;
    case 2:  //Escritura
      //Recibo los Leds que quiero encender
      if (Serial.available() > 0) {
        numeroLeds = Serial.read();  //Recibo el número de Leds que quiero encender
        delay(10);
        for(int i=0;i<numeroLeds;i++){  //Recorro el bucle tantas veces como número de Leds quiera encender.
          if (Serial.available() > 0) {
            Led = Serial.read();  //Guardo la posición del Led que quiero encender
          }
          if (Serial.available() > 0) {
            intensidadLed = Serial.read();  //Guardo la intensidad del Led que quiero encender
          }
          intensidadLed=((intensidadLed*16)-1);
          Tlc.set(matriz_cambio[Led], intensidadLed);  //Configuramos los TLC para encender el led con esa intensidad.
          Tlc.update();  //Hacemos un update para que se encienda el Led.
          delay(10);
          comando=0;
        }
        delay(2000);
      }
      break;
    default:
      break;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Enciende_Leds(){  //Funcion para encender los leds de los botones que esten pulsados

  Captura_Estado_Botones();  //Capturamos el estado de los botones
  for(int i=0;i<4;i++){
    for(int j=0;j<4;j++){
      if(matriz_botones[j][i]==0){  //Si el botón está pulsado...
        for(int k=0;k<3;k++){
          Tlc.set(matriz_leds[j][i][k],4095);  //Configuramos los TLC para encender los tres leds de ese boton a maxima intensidad.
        }
        Tlc.update();  //Hacemos un update para que se enciendam los Leds.
        delay(10);
      }
      else if(matriz_botones[j][i]==1){  //Si el botón no está pulsado
        for(int k=0;k<3;k++){
          Tlc.set(matriz_leds[j][i][k],0);  //Configuramos los TLC para apagar los tres leds de ese boton (intensidad=0).
        }
        Tlc.update();  //Hacemos un update para que se apague el Led.
        delay(10);
      }    
    }
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Enciende_Leds_Verdes(){  //Funcion para encender los Leds Verdes
  for(int j=0;j<4096;j=j+100){
    for(int i=0;i<16;i++){
      Tlc.set(Led_Verdes[i],j);  //Encendemos todos los Leds Verdes incrementandoles la intensidad
    }
    Tlc.update();
    delay(10);
  }
  delay(500);
  for(int j=4095;j>0;j=j-100){
    for(int i=0;i<16;i++){
      Tlc.set(Led_Verdes[i],j);  //Apagamos todos los Leds Verdes disminuyendoles la intensidad
    }
  Tlc.update();
  delay(10);
  }
  Tlc.setAll(0);
  Tlc.update();
  delay(10);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Enciende_Leds_Rojos(){  //Funcion para enceder los Leds Rojos
  for(int j=0;j<4096;j=j+100){
    for(int i=0;i<16;i++){
      Tlc.set(Led_Rojos[i],j);  //Encendemos todos los Leds Rojos incrementandoles la intensidad
    }
    Tlc.update();
    delay(10);
  }
  delay(500);
  for(int j=4095;j>0;j=j-100){
    for(int i=0;i<16;i++){
      Tlc.set(Led_Rojos[i],j);  //Apagamos todos los Leds Rojos disminuyendoles la intensidad
    }
  Tlc.update();
  delay(10);
  }
  Tlc.setAll(0);
  Tlc.update();
  delay(10);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Enciende_Leds_Azules(){
  for(int j=0;j<4096;j=j+100){
    for(int i=0;i<16;i++){
      Tlc.set(Led_Azules[i],j);  //Encendemos todos los Leds Azules incrementandoles la intensidad
    }
    Tlc.update();
    delay(10);
  }
  delay(500);
  for(int j=4095;j>0;j=j-100){
    for(int i=0;i<16;i++){
      Tlc.set(Led_Azules[i],j);  //Apagamos todos los Leds Azules disminuyendoles la intensidad
    }
  Tlc.update();
  delay(10);
  }
  Tlc.setAll(0);
  Tlc.update();
  delay(10);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Enciende_Leds_Aleatorios(){  //Función para encender Leds de distintos colores aleatoriamente
  for(int i=0;i<80;i++){
    Tlc.set(Led_Azules[random(0,16)],4095);
    Tlc.set(Led_Rojos[random(0,16)],4095);
    Tlc.set(Led_Verdes[random(0,16)],4095);
    Tlc.update();
    delay(20);
  }
  Tlc.setAll(0);
  Tlc.update();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Mostrar_Matriz()  //Función adicional para mostrar la matriz de los botones
{
  for(int i = 0;i<4; i++){
    for(int j = 0; j<4; j++){
      Serial.print(matriz_botones[j][i]);
      Serial.print(" ");
    }
    Serial.println();
  }
  Serial.println();
  delay(1000);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Reorganizar_Botones() //Función para hacer coincidir los botones de la placa con la matriz
{
  int matriz_botones_p[4][4] = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};

  for(int a = 0; a < 4; a++){
    matriz_botones_p[0][a] = matriz_botones[0][a];
    matriz_botones_p[1][a] = matriz_botones[3][a];
    matriz_botones_p[2][a] = matriz_botones[1][a];
    matriz_botones_p[3][a] = matriz_botones[2][a];
  }

  for(int a = 0; a < 4; a++){
    for(int b = 0; b < 4; b++){
      matriz_botones[a][b] = matriz_botones_p[a][b];
    }
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Captura_Estado_Botones()  //Función para capturar el estado de cada uno de los botones de la placa
{
  for(int i=0;i<4;i++){  //Se van alimentando cada una de las columnas de la placa
    if(i==0){
      analogWrite(A0,0);
      analogWrite(A1,1023);
      analogWrite(A2,1023);
      analogWrite(A3,1023);
    }
    else if(i==1){
      analogWrite(A0,1023);
      analogWrite(A1,0);
      analogWrite(A2,1023);
      analogWrite(A3,1023);
    }
    else if(i==2){
      analogWrite(A0,1023);
      analogWrite(A1,1023);
      analogWrite(A2,0);
      analogWrite(A3,1023);
    }
    else if(i==3){
      analogWrite(A0,1023);
      analogWrite(A1,1023);
      analogWrite(A2,1023);
      analogWrite(A3,0);
    }
    //Se va recibiendo el valor de cada fila y columna
    matriz_botones[0][i] = digitalRead(2);
    matriz_botones[1][i] = digitalRead(4);
    matriz_botones[2][i] = digitalRead(5);
    matriz_botones[3][i] = digitalRead(6);

    delay(10);
  }
  Reorganizar_Botones();  //Una vez recogidos los valores reorganizamos la matriz
}

