
import processing.serial.*;
Serial myPort;

/*******VARIABLES PARA EL ENVÍO DEL COMANDO************/
int comando=2;  //El programador deberá cambiar a 1 para hacer lectura (botones) o a 2 para hacer escritura (leds).
int comando_enviado=0;

/*******VARIABLES PARA LA LECTURA DE BOTONES************/
int[][] matrizBotones = { {0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0} };  // Aquí se guardan los estados de los botones cuando hagamos la lectura

/*******VARIABLES PARA LA ESCRITURA DE LEDS************/
int numeroLeds=8;   // A la hora de la escritura, el programador debera modificar esta variable para decir cuantos leds quiere encender.
//El programador debera modificar tantos valores como numeroLeds haya puesto anteriormente, tanto de la variable Led como de la variable intentsidadLed
int [] Led = {36,37,38,39,5,15,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};  //Indica que la posición del Led que quiere encender (48 posiciones = 48 Leds)
int [] intensidadLed = {256,100,200,250,256,256,150,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};  //Indica que intensidad quieres poner al Led


void setup() {
  println(Serial.list());
  myPort = new Serial(this, Serial.list()[0], 9600);
}

void draw() {
  delay(2000);
  if(comando_enviado==0){  
    myPort.write(comando);  //Mandamos el comando dependiendo de lo que queramos hacer.
    comando_enviado=1;  //Para enviar solamente una vez el comando
  }
  switch(comando) {  //Dependiendo del valor de comando haremos una cosa u otra.
  case 1: //Lectura
    //Leo el valor de los botones pulsados
    while (myPort.available () > 0) {
      for (int i=0;i<4;i++) {  //Aumento la columna
        for (int j=0;j<4;j++) {  //Aumento la fila
          matrizBotones[j][i] = myPort.read();  //Recorro por columnas y voy guardando el valor de cada botón en la matriz
          delay(50);
          if(matrizBotones[j][i]==0){  //Si alguno de esos valores es igual a 0 quiere decir que ese botón está pulsado.
            println("Boton " + (i+1) + "," + (j+1) +  " pulsado");  //Mostramos por pantalla que ese botón está pulsado.
          }    
        }
      }
      //Mostramos la matriz entera a continuación:
      for(int i=0;i<4;i++){
        for(int j=0;j<4;j++){
          print(matrizBotones[j][i]);
          print(" ");
        }
        println();
      }
      comando=0;
    }
    break;
  case 2:  //Escritura
    //Mando los Leds que quiero encender
    delay(10);
    myPort.write(numeroLeds);  //En primer lugar mando el número de Leds que quiero encender.
    for (int i=0;i<numeroLeds;i++) {  //Haré tantos envíos como numero de Leds quiera encender
      myPort.write(Led[i]);  //Mando la posición del Led que quiero encender (0~48)
      myPort.write(intensidadLed[i]);  //Mando el número con la intensidad que quiero encender dicho Led (0~256):
      //En la recepción se multiplica el valor por 16 para que se pueda encender a la máxima intensidad 256x16=4096
      delay(10);
    }
    delay(10);
    comando=0;
    break;
  default:
    // si nada coincide, ejecuta el "default"
    // el "default" es opcional
  }
}

